OSDN Git Service

contrib:
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/genopt.sh
84 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
85 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
86 # And then, language-specific files
87 gcc/cp/cfns.h: gcc/cp/cfns.gperf
88 gcc/java/keyword.h: gcc/java/keyword.gperf
89 # testsuite
90 # Without this, _Pragma3.c can have a false negative.
91 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
92 # Similarly, without this, you will see:
93 # direct2s.c:35: warning: current file is older than direct2.c
94 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
95 # lto-plugin
96 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
97 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
98 # And libraries, at last
99 libbanshee/configure: libbanshee/configure.ac
100 libmudflap/configure: libmudflap/configure.ac
101 libobjc/configure: libobjc/configure.ac
102 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
103 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
104 zlib/configure: zlib/configure.ac zlib/aclocal.m4
105 fastjar/aclocal.m4: fastjar/configure.ac
106 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
107 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
108 boehm-gc/aclocal.m4: boehm-gc/configure.ac
109 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
110 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
111 libada/configure: libada/configure.ac
112 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
113 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
114 libffi/configure: libffi/configure.ac libffi/aclocal.m4
115 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
116 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
117 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
118 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
119 libjava/aclocal.m4: libjava/configure.ac
120 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
121 libjava/configure: libjava/configure.ac libjava/aclocal.m4
122 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
123 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
124 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
125 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
126 libcpp/aclocal.m4: libcpp/configure.ac
127 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
128 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
129 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
130 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
131 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
132 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
133 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
134 # Top level
135 Makefile.in: Makefile.tpl Makefile.def
136 configure: configure.ac config/acx.m4
137 EOF
138 }
139
140
141 # This function touches generated files such that the ``end'' user does
142 # not have to rebuild them.
143 touch_files () {
144     rm -f Makefile.$$
145     echo 'all: \' > Makefile.$$
146     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
147     echo '; @true' >> Makefile.$$
148     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
149     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
150     echo ':' >> Makefile.$$
151     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
152     echo '      echo Touching $@...; \' >> Makefile.$$
153     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
154     echo '      touch $@' >> Makefile.$$
155     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
156
157     # We would have to explicitly shut off the "Entering... Leaving..."
158     # messages through "--no-print-directory" to handle the case when
159     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
160     # Makefile, not just make).  Passing only "-s" doesn't help then,
161     # because make has helpfully added "-w" to MAKEFLAGS automatically.
162     # Unfortunately we do not require GNU make other than for building
163     # and testing, so let's just grep known text explicitly echoed by
164     # the rule.
165     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
166       sleep 1
167     done 2>&1
168     rm -f Makefile.$$
169 }
170
171
172 # Whenever we update the tree or install a patch, we may be modifying
173 # this script.  By re-execing it, we ensure that the appropriate
174 # dependencies and rules will be used.
175 touch_files_reexec () {
176     chat "Adjusting file timestamps"
177     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
178 }
179
180 # This functions applies a patch to an existing tree.
181 apply_patch () {
182     if [ -f "$1" ]; then
183         echo "Applying patch file $1"
184         case $1 in
185         *gz)
186             gzip -d -c "$1" | patch -p1 ;;
187         *bz2)
188             bzip2 -d -c "$1" | patch -p1 ;;
189         *)
190             patch -p1 < "$1";;
191         esac
192     fi
193     touch_files_reexec
194 }
195
196 # Check whether this indeed looks like a local tree.
197 if [ ! -f gcc/version.c ]; then
198     echo "This does not seem to be a GCC tree!"
199     exit
200 fi
201
202 case "$1" in
203 --silent)
204     silent=t
205     shift
206     ;;
207 esac
208
209 case "$1" in
210 # First of all, check whether we are going to process a patch.
211 --patch)
212     if test "$#" != 2; then
213         echo "$1" expects only one argument >&2
214         exit 1
215     fi
216     apply_patch "${2}"
217     exit $?
218     ;;
219
220 --touch)
221     if test "$#" != 1; then
222         echo "$1" does not expect any argument >&2
223         exit 1
224     fi
225     touch_files
226     exit $?
227     ;;
228
229 --list)
230     if test "$#" != 1; then
231         echo "$1" does not expect any argument >&2
232         exit 1
233     fi
234     files_and_dependencies | sed 's/ /: /'
235     exit $?
236     ;;
237
238 --help)
239     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
240 \
241
242 p
243 }' \
244         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
245     exit $?
246     ;;
247
248 esac
249
250 # Check for known version control systems.
251 if [ -d .git ]; then
252     GCC_GIT=${GCC_GIT-${GIT-git}}
253     vcs_type="git"
254 elif [ -d .hg ]; then
255     GCC_HG=${GCC_HG-${HG-hg}}
256     vcs_type="hg"
257 elif [ -d .svn ]; then
258     GCC_SVN=${GCC_SVN-${SVN-svn}}
259     vcs_type="svn"
260 else
261     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
262     exit
263 fi
264
265 # Check command-line options
266 if [ x"${1}"x = x"--nostdflags"x ]; then
267     shift
268 else
269     set -- $UPDATE_OPTIONS ${1+"$@"}
270 fi
271
272 case $vcs_type in
273     git)
274         chat "Updating GIT tree"
275
276         $GCC_GIT diff --quiet --exit-code HEAD
277         if [ $? -ne 0 ]; then
278             echo "Attempting to update a dirty git tree!" >&2
279             echo "Commit or stash your changes first and retry." >&2
280             exit 1
281         fi
282
283         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
284         if [ $? -ne 0 ]; then
285             (touch_files_reexec)
286             echo "git pull of full tree failed." >&2
287             exit 1
288         fi
289
290         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
291         branch=`$GCC_GIT name-rev --name-only HEAD || :`
292         ;;    
293
294     hg)
295         chat "Updating HG tree"
296
297         # Add -q so untracked files aren't listed.
298         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
299             echo "Attempting to update a dirty hg tree!" >&2
300             echo "Commit or revert your changes first and retry." >&2
301             exit 1
302         fi
303
304         # Check for mq extension.  mq patches must be popped so tip has
305         # been converted from the SVN tree.
306         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
307             # FIXME: Perhaps pop queue instead?  We could do that since we
308             # know the tree is clean.
309             echo "Attempting to update hg tree with mq patches applied!" >&2
310             echo "Pop your patches first and retry." >&2
311             exit 1
312         fi
313
314         # Update tree, but make sure to only pull the default branch.
315         # Otherwise all branches in the upstream repo are added, even if
316         # only a single one has been cloned.
317         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
318         if [ $? -ne 0 ]; then
319             (touch_files_reexec)
320             echo "hg pull of full tree failed." >&2
321             exit 1
322         fi
323
324         # Update tree.  Needs to be done separately from pull so
325         # gcc_update -rREV works.
326         $GCC_HG update ${silent+-q} ${1+"$@"}
327         if [ $? -ne 0 ]; then
328             (touch_files_reexec)
329             echo "hg update of full tree failed." >&2
330             exit 1
331         fi
332
333         # Extract SVN revision corresponding to parents, as stored by
334         # hg convert.  Before hg 1.4.3, there's no template keyword
335         # corresponding to the extra: tag, so need to use hg log --debug
336         # to extract the info.
337         parents=`$GCC_HG parents --template '{rev}'`
338         revision=`$GCC_HG log --debug -r$parents | \
339             sed -ne "/^extra:.*convert_revision=svn:/ {
340                 s%^.*@%%
341                 p
342             }"`
343         branch=`$GCC_HG branch`
344         # trunk in SVN parlance shows up as default branch in hg.
345         [ x$branch = x"default" ] && branch="trunk"
346         ;;
347
348     svn)
349         chat "Updating SVN tree"
350
351         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
352         if [ $? -ne 0 ]; then
353             (touch_files_reexec)
354             echo "SVN update of full tree failed." >&2
355             exit 1
356         fi
357
358         revision=`svn info | awk '/Revision:/ { print $2 }'`
359         branch=`svn info | sed -ne "/URL:/ {
360             s,.*/trunk,trunk,
361             s,.*/branches/,,
362             s,.*/tags/,,
363             p
364         }"`
365         ;;
366 esac
367
368 rm -f LAST_UPDATED gcc/REVISION
369 {
370     date
371     echo "`TZ=UTC date` (revision $revision)"
372 } > LAST_UPDATED
373 echo "[$branch revision $revision]" > gcc/REVISION
374
375 touch_files_reexec